package fr.inria.phoenix.diasuite.framework.context.event;

import java.io.Serializable;

/**
 * Container for the indices of the context <code>Event</code>.
 * 
 * <pre>
 * context Event as String indexed by periodicity as Integer {
 * 	when provided message from Input
 * 	maybe publish;	
 * }
 * </pre>
 */
public final class EventIndices implements Serializable {
    private static final long serialVersionUID = 0;
    
    public EventIndices(java.lang.Integer periodicity) {
        this._periodicity = periodicity;
    }
    
    // Code for index periodicity
    private java.lang.Integer _periodicity;
    
    /**
     * Get the <code>periodicity</code> index
     * 
     * @return the value of the <code>periodicity</code> index
     */
    public java.lang.Integer periodicity() {
        return _periodicity;
    }
    
    /**
     * Set the <code>periodicity</code> index
     * 
     * @param newPeriodicity the new value for the <code>periodicity</code> index
     */
    public void setPeriodicity(java.lang.Integer newPeriodicity) {
        this._periodicity = newPeriodicity;
    }
    // End of code for index periodicity
    
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((_periodicity == null) ? 0 : _periodicity.hashCode());
        return result;
    }
    
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        EventIndices other = (EventIndices) obj;
        if (_periodicity == null) {
            if (other._periodicity != null)
                return false;
        } else if (!_periodicity.equals(other._periodicity))
            return false;
        return true;
    }
}
