package fr.inria.phoenix.diasuite.framework.datatype.gpscoordinates;

import java.io.Serializable;

/**
 * <pre>
 * structure GPSCoordinates {
 * 	latitude as Float;
 * 	longitude as Float;
 * }
 * </pre>
 */
public class GPSCoordinates implements Serializable {
    private static final long serialVersionUID = 0;

    // Code for field latitude
    private java.lang.Float latitude;
    
    /**
     * Returns the value of the latitude field.
     * 
     * <pre>
     * latitude as Float
     * </pre>
     * @return the value of latitude
     */
    public java.lang.Float getLatitude() {
        return latitude;
    }
    
    /**
     * Set the value of the latitude field.
     * 
     * <pre>
     * latitude as Float
     * </pre>
     * @param latitude the new value of latitude
     */
    public void setLatitude(java.lang.Float latitude) {
        this.latitude = latitude;
    }
    // End of code for field latitude

    // Code for field longitude
    private java.lang.Float longitude;
    
    /**
     * Returns the value of the longitude field.
     * 
     * <pre>
     * longitude as Float
     * </pre>
     * @return the value of longitude
     */
    public java.lang.Float getLongitude() {
        return longitude;
    }
    
    /**
     * Set the value of the longitude field.
     * 
     * <pre>
     * longitude as Float
     * </pre>
     * @param longitude the new value of longitude
     */
    public void setLongitude(java.lang.Float longitude) {
        this.longitude = longitude;
    }
    // End of code for field longitude

    public GPSCoordinates() {
    }

    public GPSCoordinates(java.lang.Float latitude,
            java.lang.Float longitude) {
        this.latitude = latitude;
        this.longitude = longitude;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((latitude == null) ? 0 : latitude.hashCode());
        result = prime * result + ((longitude == null) ? 0 : longitude.hashCode());
        return result;
    }
    
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        GPSCoordinates other = (GPSCoordinates) obj;
        if (latitude == null) {
            if (other.latitude != null)
                return false;
        } else if (!latitude.equals(other.latitude))
            return false;
        if (longitude == null) {
            if (other.longitude != null)
                return false;
        } else if (!longitude.equals(other.longitude))
            return false;
        return true;
    }

    @Override
    public String toString() {
        return "GPSCoordinates [" + 
            "latitude=" + latitude +", " + 
            "longitude=" + longitude +
        "]";
    }
}
