package fr.inria.phoenix.diasuite.framework.device.input;

import fr.inria.diagen.core.ServiceConfiguration;
import fr.inria.diagen.core.exception.InvocationException;
import fr.inria.diagen.core.network.RemoteServiceInfo;
import fr.inria.diagen.core.service.local.Service;

/**
 * <pre>
 * device Input extends Service {
 * 	source message as String indexed by params as String [];
 * }
 * </pre>
 */
public abstract class AbstractInput extends Service {
    
    public AbstractInput(ServiceConfiguration serviceConfiguration,
            java.lang.String idValue) {
        super("/Device/Device/Service/Input/", serviceConfiguration);
        updateId(idValue);
    }
    
    // Methods from the Service class
    @Override
    public final java.util.Map<String, Object> getAttributesCalled(java.util.Map<String, Object> properties, RemoteServiceInfo source) {
        java.util.Map<String, Object> attributes = new java.util.HashMap<String, Object>();
        attributes.put("id", _id);
        return attributes;
    }
    
    @Override
    protected final void internalPostInitialize() {
        postInitialize();
    }
    
    @SuppressWarnings("all")
    @Override
    public final Object orderCalled(java.util.Map<String, Object> properties, RemoteServiceInfo source, String orderName, Object... args) throws Exception {
        throw new InvocationException("Undefined method name " + orderName);
    }
    
    @Override
    public Object getValueCalled(java.util.Map<String, Object> properties, RemoteServiceInfo source, String orderName, Object... args) throws Exception {
        if (orderName.equals("id")) {
            return _id;
        }
        if (orderName.equals("isAlive")) {
            return getIsAlive();
        }
        if (orderName.equals("message")) {
            return getMessage((java.util.List<java.lang.String>) args[0]);
        }
        throw new InvocationException("Undefined method name " + orderName);
    }
    // End of methods from the Service class
    
    // Code for the attribute id from device Device
    private java.lang.String _id;
    
    /**
     * Set the value of the <code>id</code> attribute from device <code>Device</code>.
     * 
     * <pre>
     * attribute id as String;
     * </pre>
     * @param newIdValue the new value of <code>id</code>
     */
    protected void updateId(java.lang.String newIdValue) {
        if (_id != newIdValue) {
            _id = newIdValue;
            updateAttribute("id", newIdValue);
        }
    }
    
    /**
     * Returns the value of the <code>id</code> attribute from device <code>Device</code>.
     * 
     * <pre>
     * attribute id as String;
     * </pre>
     * @return the value of <code>id</code>
     */
    public java.lang.String getId() {
        return _id;
    }
    // End of code for the attribute id from device Device
    
    // Code for source isAlive from device Device
    private java.lang.Boolean _isAlive;
    
    /**
     * Publish the value of source <code>isAlive</code> from device <code>Device</code>.
     * 
     * <pre>
     * source isAlive as Boolean;
     * </pre>
     * @param newIsAliveValue the new value for the source <code>isAlive</code>
     */
    protected void publishIsAlive(java.lang.Boolean newIsAliveValue) {
        _isAlive = newIsAliveValue;
        getProcessor().publishValue(getOutProperties(), "isAlive", newIsAliveValue); 
    }
    
    /**
     * Returns the value of source <code>isAlive</code> from device <code>Device</code>.
     * 
     * <pre>
     * source isAlive as Boolean;
     * </pre>
     * @return the value of the source <code>isAlive</code>
     */
    protected java.lang.Boolean getIsAlive() throws Exception {
        return _isAlive;
    }
    // End of code for source isAlive from device Device
    
    // Code for source message from device Input
    private java.util.HashMap<MessageIndices, java.lang.String> _message = new java.util.HashMap<MessageIndices, java.lang.String>();
    
    /**
     * Publish the value of source <code>message</code> from device <code>Input</code>.
     * 
     * <pre>
     * source message as String indexed by params as String [];
     * </pre>
     * @param newMessageValue the new value for the source <code>message</code>
     * @param params the value of the index <code>params</code>
     */
    protected void publishMessage(java.lang.String newMessageValue,
            java.util.List<java.lang.String> params) {
        MessageIndices _indices_ = new MessageIndices(params);
        _message.put(_indices_, newMessageValue);
        getProcessor().publishValue(getOutProperties(), "message", newMessageValue, params); 
    }
    
    /**
     * Returns the value of source <code>message</code> from device <code>Input</code>.
     * 
     * <pre>
     * source message as String indexed by params as String [];
     * </pre>
     * @param params the value of the index <code>params</code>
     * @return the value of the source <code>message</code>
     */
    protected java.lang.String getMessage(java.util.List<java.lang.String> params) throws Exception {
        return _message.get(new MessageIndices(params));
    }
    // End of code for source message from device Input
}
