package fr.inria.phoenix.diasuite.framework.device.input;

import java.io.Serializable;

/**
 * Container for the indices of the source <code>message</code> from device <code>Input</code>.
 * 
 * <pre>
 * source message as String indexed by params as String [];
 * </pre>
 */
public final class MessageIndices implements Serializable {
    private static final long serialVersionUID = 0;
    
    public MessageIndices(java.util.List<java.lang.String> params) {
        this._params = params;
    }
    
    // Code for index params
    private java.util.List<java.lang.String> _params;
    
    /**
     * Get the <code>params</code> index
     * 
     * @return the value of the <code>params</code> index
     */
    public java.util.List<java.lang.String> params() {
        return _params;
    }
    
    /**
     * Set the <code>params</code> index
     * 
     * @param newParams the new value for the <code>params</code> index
     */
    public void setParams(java.util.List<java.lang.String> newParams) {
        this._params = newParams;
    }
    // End of code for index params
    
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((_params == null) ? 0 : _params.hashCode());
        return result;
    }
    
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        MessageIndices other = (MessageIndices) obj;
        if (_params == null) {
            if (other._params != null)
                return false;
        } else if (!_params.equals(other._params))
            return false;
        return true;
    }
}
