package fr.inria.phoenix.diasuite.framework.device.pallettracker;

import fr.inria.diagen.core.ServiceConfiguration;
import fr.inria.diagen.core.exception.InvocationException;
import fr.inria.diagen.core.network.RemoteServiceInfo;
import fr.inria.diagen.core.service.local.Service;

/**
 * <pre>
 * device PalletTracker extends Sensor {
 * 	source state as State;
 * 	source position as GPSCoordinates indexed by params as String [];
 * }
 * </pre>
 */
public abstract class AbstractPalletTracker extends Service {
    
    public AbstractPalletTracker(ServiceConfiguration serviceConfiguration,
            java.lang.String idValue,
            java.lang.String locationValue,
            java.lang.String userValue) {
        super("/Device/Device/PhysicalDevice/Sensor/PalletTracker/", serviceConfiguration);
        updateId(idValue);
        updateLocation(locationValue);
        updateUser(userValue);
    }
    
    // Methods from the Service class
    @Override
    public final java.util.Map<String, Object> getAttributesCalled(java.util.Map<String, Object> properties, RemoteServiceInfo source) {
        java.util.Map<String, Object> attributes = new java.util.HashMap<String, Object>();
        attributes.put("id", _id);
        attributes.put("location", _location);
        attributes.put("user", _user);
        return attributes;
    }
    
    @Override
    protected final void internalPostInitialize() {
        postInitialize();
    }
    
    @SuppressWarnings("all")
    @Override
    public final Object orderCalled(java.util.Map<String, Object> properties, RemoteServiceInfo source, String orderName, Object... args) throws Exception {
        throw new InvocationException("Undefined method name " + orderName);
    }
    
    @Override
    public Object getValueCalled(java.util.Map<String, Object> properties, RemoteServiceInfo source, String orderName, Object... args) throws Exception {
        if (orderName.equals("id")) {
            return _id;
        }
        if (orderName.equals("location")) {
            return _location;
        }
        if (orderName.equals("user")) {
            return _user;
        }
        if (orderName.equals("isAlive")) {
            return getIsAlive();
        }
        if (orderName.equals("position")) {
            return getPosition((java.util.List<java.lang.String>) args[0]);
        }
        if (orderName.equals("state")) {
            return getState();
        }
        throw new InvocationException("Undefined method name " + orderName);
    }
    // End of methods from the Service class
    
    // Code for the attribute id from device Device
    private java.lang.String _id;
    
    /**
     * Set the value of the <code>id</code> attribute from device <code>Device</code>.
     * 
     * <pre>
     * attribute id as String;
     * </pre>
     * @param newIdValue the new value of <code>id</code>
     */
    protected void updateId(java.lang.String newIdValue) {
        if (_id != newIdValue) {
            _id = newIdValue;
            updateAttribute("id", newIdValue);
        }
    }
    
    /**
     * Returns the value of the <code>id</code> attribute from device <code>Device</code>.
     * 
     * <pre>
     * attribute id as String;
     * </pre>
     * @return the value of <code>id</code>
     */
    public java.lang.String getId() {
        return _id;
    }
    // End of code for the attribute id from device Device
    
    // Code for the attribute location from device PhysicalDevice
    private java.lang.String _location;
    
    /**
     * Set the value of the <code>location</code> attribute from device <code>PhysicalDevice</code>.
     * 
     * <pre>
     * attribute location as String;
     * </pre>
     * @param newLocationValue the new value of <code>location</code>
     */
    protected void updateLocation(java.lang.String newLocationValue) {
        if (_location != newLocationValue) {
            _location = newLocationValue;
            updateAttribute("location", newLocationValue);
        }
    }
    
    /**
     * Returns the value of the <code>location</code> attribute from device <code>PhysicalDevice</code>.
     * 
     * <pre>
     * attribute location as String;
     * </pre>
     * @return the value of <code>location</code>
     */
    public java.lang.String getLocation() {
        return _location;
    }
    // End of code for the attribute location from device PhysicalDevice
    
    // Code for the attribute user from device PhysicalDevice
    private java.lang.String _user;
    
    /**
     * Set the value of the <code>user</code> attribute from device <code>PhysicalDevice</code>.
     * 
     * <pre>
     * attribute user as String;
     * </pre>
     * @param newUserValue the new value of <code>user</code>
     */
    protected void updateUser(java.lang.String newUserValue) {
        if (_user != newUserValue) {
            _user = newUserValue;
            updateAttribute("user", newUserValue);
        }
    }
    
    /**
     * Returns the value of the <code>user</code> attribute from device <code>PhysicalDevice</code>.
     * 
     * <pre>
     * attribute user as String;
     * </pre>
     * @return the value of <code>user</code>
     */
    public java.lang.String getUser() {
        return _user;
    }
    // End of code for the attribute user from device PhysicalDevice
    
    // Code for source isAlive from device Device
    private java.lang.Boolean _isAlive;
    
    /**
     * Publish the value of source <code>isAlive</code> from device <code>Device</code>.
     * 
     * <pre>
     * source isAlive as Boolean;
     * </pre>
     * @param newIsAliveValue the new value for the source <code>isAlive</code>
     */
    protected void publishIsAlive(java.lang.Boolean newIsAliveValue) {
        _isAlive = newIsAliveValue;
        getProcessor().publishValue(getOutProperties(), "isAlive", newIsAliveValue); 
    }
    
    /**
     * Returns the value of source <code>isAlive</code> from device <code>Device</code>.
     * 
     * <pre>
     * source isAlive as Boolean;
     * </pre>
     * @return the value of the source <code>isAlive</code>
     */
    protected java.lang.Boolean getIsAlive() throws Exception {
        return _isAlive;
    }
    // End of code for source isAlive from device Device
    
    // Code for source position from device PalletTracker
    private java.util.HashMap<PositionIndices, fr.inria.phoenix.diasuite.framework.datatype.gpscoordinates.GPSCoordinates> _position = new java.util.HashMap<PositionIndices, fr.inria.phoenix.diasuite.framework.datatype.gpscoordinates.GPSCoordinates>();
    
    /**
     * Publish the value of source <code>position</code> from device <code>PalletTracker</code>.
     * 
     * <pre>
     * source position as GPSCoordinates indexed by params as String [];
     * </pre>
     * @param newPositionValue the new value for the source <code>position</code>
     * @param params the value of the index <code>params</code>
     */
    protected void publishPosition(fr.inria.phoenix.diasuite.framework.datatype.gpscoordinates.GPSCoordinates newPositionValue,
            java.util.List<java.lang.String> params) {
        PositionIndices _indices_ = new PositionIndices(params);
        _position.put(_indices_, newPositionValue);
        getProcessor().publishValue(getOutProperties(), "position", newPositionValue, params); 
    }
    
    /**
     * Returns the value of source <code>position</code> from device <code>PalletTracker</code>.
     * 
     * <pre>
     * source position as GPSCoordinates indexed by params as String [];
     * </pre>
     * @param params the value of the index <code>params</code>
     * @return the value of the source <code>position</code>
     */
    protected fr.inria.phoenix.diasuite.framework.datatype.gpscoordinates.GPSCoordinates getPosition(java.util.List<java.lang.String> params) throws Exception {
        return _position.get(new PositionIndices(params));
    }
    // End of code for source position from device PalletTracker
    
    // Code for source state from device PalletTracker
    private fr.inria.phoenix.diasuite.framework.datatype.state.State _state;
    
    /**
     * Publish the value of source <code>state</code> from device <code>PalletTracker</code>.
     * 
     * <pre>
     * source state as State;
     * </pre>
     * @param newStateValue the new value for the source <code>state</code>
     */
    protected void publishState(fr.inria.phoenix.diasuite.framework.datatype.state.State newStateValue) {
        _state = newStateValue;
        getProcessor().publishValue(getOutProperties(), "state", newStateValue); 
    }
    
    /**
     * Returns the value of source <code>state</code> from device <code>PalletTracker</code>.
     * 
     * <pre>
     * source state as State;
     * </pre>
     * @return the value of the source <code>state</code>
     */
    protected fr.inria.phoenix.diasuite.framework.datatype.state.State getState() throws Exception {
        return _state;
    }
    // End of code for source state from device PalletTracker
}
