package fr.inria.phoenix.diasuite.framework.device.pallettrackingdb;

import fr.inria.diagen.core.ServiceConfiguration;
import fr.inria.diagen.core.exception.InvocationException;
import fr.inria.diagen.core.network.RemoteServiceInfo;
import fr.inria.diagen.core.service.local.Service;

/**
 * ------------------
 * DB
 * ------------------------------------
 * 
 * <pre>
 * device PalletTrackingDB extends Service {
 * 	source warehouse as String indexed by position as GPSCoordinates;
 * 	action InsertPalletState;
 * }
 * </pre>
 */
public abstract class AbstractPalletTrackingDB extends Service {
    
    public AbstractPalletTrackingDB(ServiceConfiguration serviceConfiguration,
            java.lang.String idValue) {
        super("/Device/Device/Service/PalletTrackingDB/", serviceConfiguration);
        updateId(idValue);
    }
    
    // Methods from the Service class
    @Override
    public final java.util.Map<String, Object> getAttributesCalled(java.util.Map<String, Object> properties, RemoteServiceInfo source) {
        java.util.Map<String, Object> attributes = new java.util.HashMap<String, Object>();
        attributes.put("id", _id);
        return attributes;
    }
    
    @Override
    protected final void internalPostInitialize() {
        postInitialize();
    }
    
    @SuppressWarnings("all")
    @Override
    public final Object orderCalled(java.util.Map<String, Object> properties, RemoteServiceInfo source, String orderName, Object... args) throws Exception {
        if (orderName.equals("insert")) {
            insert((fr.inria.phoenix.diasuite.framework.datatype.palletstate.PalletState) args[0]);
            return null;
        }
        throw new InvocationException("Undefined method name " + orderName);
    }
    
    @Override
    public Object getValueCalled(java.util.Map<String, Object> properties, RemoteServiceInfo source, String orderName, Object... args) throws Exception {
        if (orderName.equals("id")) {
            return _id;
        }
        if (orderName.equals("isAlive")) {
            return getIsAlive();
        }
        if (orderName.equals("warehouse")) {
            return getWarehouse((fr.inria.phoenix.diasuite.framework.datatype.gpscoordinates.GPSCoordinates) args[0]);
        }
        throw new InvocationException("Undefined method name " + orderName);
    }
    // End of methods from the Service class
    
    // Code for the attribute id from device Device
    private java.lang.String _id;
    
    /**
     * Set the value of the <code>id</code> attribute from device <code>Device</code>.
     * 
     * <pre>
     * attribute id as String;
     * </pre>
     * @param newIdValue the new value of <code>id</code>
     */
    protected void updateId(java.lang.String newIdValue) {
        if (_id != newIdValue) {
            _id = newIdValue;
            updateAttribute("id", newIdValue);
        }
    }
    
    /**
     * Returns the value of the <code>id</code> attribute from device <code>Device</code>.
     * 
     * <pre>
     * attribute id as String;
     * </pre>
     * @return the value of <code>id</code>
     */
    public java.lang.String getId() {
        return _id;
    }
    // End of code for the attribute id from device Device
    
    // Code for source isAlive from device Device
    private java.lang.Boolean _isAlive;
    
    /**
     * Publish the value of source <code>isAlive</code> from device <code>Device</code>.
     * 
     * <pre>
     * source isAlive as Boolean;
     * </pre>
     * @param newIsAliveValue the new value for the source <code>isAlive</code>
     */
    protected void publishIsAlive(java.lang.Boolean newIsAliveValue) {
        _isAlive = newIsAliveValue;
        getProcessor().publishValue(getOutProperties(), "isAlive", newIsAliveValue); 
    }
    
    /**
     * Returns the value of source <code>isAlive</code> from device <code>Device</code>.
     * 
     * <pre>
     * source isAlive as Boolean;
     * </pre>
     * @return the value of the source <code>isAlive</code>
     */
    protected java.lang.Boolean getIsAlive() throws Exception {
        return _isAlive;
    }
    // End of code for source isAlive from device Device
    
    // Code for source warehouse from device PalletTrackingDB
    private java.util.HashMap<WarehouseIndices, java.lang.String> _warehouse = new java.util.HashMap<WarehouseIndices, java.lang.String>();
    
    /**
     * Publish the value of source <code>warehouse</code> from device <code>PalletTrackingDB</code>.
     * 
     * <pre>
     * source warehouse as String indexed by position as GPSCoordinates;
     * </pre>
     * @param newWarehouseValue the new value for the source <code>warehouse</code>
     * @param position the value of the index <code>position</code>
     */
    protected void publishWarehouse(java.lang.String newWarehouseValue,
            fr.inria.phoenix.diasuite.framework.datatype.gpscoordinates.GPSCoordinates position) {
        WarehouseIndices _indices_ = new WarehouseIndices(position);
        _warehouse.put(_indices_, newWarehouseValue);
        getProcessor().publishValue(getOutProperties(), "warehouse", newWarehouseValue, position); 
    }
    
    /**
     * Returns the value of source <code>warehouse</code> from device <code>PalletTrackingDB</code>.
     * 
     * <pre>
     * source warehouse as String indexed by position as GPSCoordinates;
     * </pre>
     * @param position the value of the index <code>position</code>
     * @return the value of the source <code>warehouse</code>
     */
    protected java.lang.String getWarehouse(fr.inria.phoenix.diasuite.framework.datatype.gpscoordinates.GPSCoordinates position) throws Exception {
        return _warehouse.get(new WarehouseIndices(position));
    }
    // End of code for source warehouse from device PalletTrackingDB
    
    /**
     * Implement this method to define the <code>insert</code> order from the <code>InsertPalletState</code> action
     * defined in device PalletTrackingDB.
     * 
     * 
     * <pre>
     * insert(value as PalletState);
     * </pre>
     * @param value parameter 1 of the order.
     */
    protected abstract void insert(fr.inria.phoenix.diasuite.framework.datatype.palletstate.PalletState value) throws Exception;
}
