package fr.inria.phoenix.diasuite.framework.device.pallettrackingdb;

import java.io.Serializable;

/**
 * Container for the indices of the source <code>warehouse</code> from device <code>PalletTrackingDB</code>.
 * 
 * <pre>
 * source warehouse as String indexed by position as GPSCoordinates;
 * </pre>
 */
public final class WarehouseIndices implements Serializable {
    private static final long serialVersionUID = 0;
    
    public WarehouseIndices(fr.inria.phoenix.diasuite.framework.datatype.gpscoordinates.GPSCoordinates position) {
        this._position = position;
    }
    
    // Code for index position
    private fr.inria.phoenix.diasuite.framework.datatype.gpscoordinates.GPSCoordinates _position;
    
    /**
     * Get the <code>position</code> index
     * 
     * @return the value of the <code>position</code> index
     */
    public fr.inria.phoenix.diasuite.framework.datatype.gpscoordinates.GPSCoordinates position() {
        return _position;
    }
    
    /**
     * Set the <code>position</code> index
     * 
     * @param newPosition the new value for the <code>position</code> index
     */
    public void setPosition(fr.inria.phoenix.diasuite.framework.datatype.gpscoordinates.GPSCoordinates newPosition) {
        this._position = newPosition;
    }
    // End of code for index position
    
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((_position == null) ? 0 : _position.hashCode());
        return result;
    }
    
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        WarehouseIndices other = (WarehouseIndices) obj;
        if (_position == null) {
            if (other._position != null)
                return false;
        } else if (!_position.equals(other._position))
            return false;
        return true;
    }
}
