package fr.inria.phoenix.diasuite.framework.misc;

import java.util.HashMap;
import java.util.Map;

import fr.inria.diagen.core.service.local.Service;

/**
 * A container for the list of available devices. For internal use by introspection libraries
 * 
 * @internal
 */
public class ClassList implements fr.inria.diagen.core.deploy.DeviceLister {

    public final Map<String, Class<? extends Service>> deviceList = new HashMap<String, Class<? extends Service>>();

    public ClassList() {        
        deviceList.put("/Device/Device/PhysicalDevice/Messenger/", fr.inria.phoenix.diasuite.framework.device.messenger.AbstractMessenger.class);    
        deviceList.put("/Device/Device/PhysicalDevice/Sensor/PalletTracker/", fr.inria.phoenix.diasuite.framework.device.pallettracker.AbstractPalletTracker.class);       
        deviceList.put("/Device/Device/PhysicalDevice/Sensor/TemperatureSensor/", fr.inria.phoenix.diasuite.framework.device.temperaturesensor.AbstractTemperatureSensor.class);
        deviceList.put("/Device/Device/Service/BuiltIn/Timer/", fr.inria.phoenix.diasuite.framework.device.timer.AbstractTimer.class);                       
        deviceList.put("/Device/Device/Service/Input/", fr.inria.phoenix.diasuite.framework.device.input.AbstractInput.class);        
        deviceList.put("/Device/Device/Service/PalletTrackingDB/", fr.inria.phoenix.diasuite.framework.device.pallettrackingdb.AbstractPalletTrackingDB.class);
    }

    public Map<String, Class<? extends Service>> getDeviceList() {
        return deviceList;
    }

}
