package fr.inria.phoenix.scenario.pallettracker.impl.context;

import fr.inria.diagen.core.ServiceConfiguration;
import fr.inria.phoenix.diasuite.framework.context.event.AbstractEvent;
import fr.inria.phoenix.diasuite.framework.device.input.MessageFromInput;

public class Event extends AbstractEvent {

	public Event(ServiceConfiguration serviceConfiguration) {
		super(serviceConfiguration);
	}

	@Override
	protected EventValuePublishable onMessageFromInput(
			MessageFromInput messageFromInput) {

		String message = messageFromInput.value();

		if (message.matches(".*event:.*")) {
			String[] event = message.split("event:");
			String[] nameAndPeriodicity = event[event.length - 1].split(";");

			return new EventValuePublishable(nameAndPeriodicity[0],
					Integer.parseInt(nameAndPeriodicity[1]), true);
		}

		return new EventValuePublishable(new String(), 0, false);
	}
}
