package fr.inria.phoenix.scenario.pallettracker.impl.context;

import fr.inria.diagen.core.ServiceConfiguration;
import fr.inria.phoenix.diasuite.framework.context.state.AbstractState;
import fr.inria.phoenix.diasuite.framework.datatype.gpscoordinates.GPSCoordinates;
import fr.inria.phoenix.diasuite.framework.datatype.palletstate.PalletState;
import fr.inria.phoenix.diasuite.framework.device.pallettracker.StateFromPalletTracker;

public class State extends AbstractState {

	public State(ServiceConfiguration serviceConfiguration) {
		super(serviceConfiguration);
	}

	@Override
	protected PalletState onStateFromPalletTracker(
			StateFromPalletTracker stateFromPalletTracker,
			DiscoverForStateFromPalletTracker discover) {

		String deviceId = stateFromPalletTracker.sender().id();
		String timeStamp = stateFromPalletTracker.value().getTimestamp();
		GPSCoordinates gpsCoordinates = discover.position(deviceId);
		Integer temperature = discover.temperature(deviceId);

		return new PalletState(gpsCoordinates, temperature, timeStamp);
	}
}
