package fr.inria.phoenix.scenario.pallettracker.impl.context;

import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

import fr.inria.diagen.core.ServiceConfiguration;
import fr.inria.phoenix.diasuite.framework.context.temperature.AbstractTemperature;
import fr.inria.phoenix.diasuite.framework.device.temperaturesensor.TemperatureFromTemperatureSensor;

public class Temperature extends AbstractTemperature {

	private Map<String, Integer> palletTemperatureMap;

	public Temperature(ServiceConfiguration serviceConfiguration) {
		super(serviceConfiguration);
		palletTemperatureMap = Collections
				.synchronizedMap(new HashMap<String, Integer>());
	}

	@Override
	protected void onTemperatureFromTemperatureSensor(
			TemperatureFromTemperatureSensor temperatureFromTemperatureSensor) {

		String id = temperatureFromTemperatureSensor.sender().id();
		Integer temperature = temperatureFromTemperatureSensor.value()
				.getValue().intValue();

		synchronized (palletTemperatureMap) {
			palletTemperatureMap.put(id, temperature);
		}
	}

	@Override
	protected Integer getValue(String id) {
		synchronized (palletTemperatureMap) {
			return palletTemperatureMap.get(id);
		}
	}
}
